//+------------------------------------------------------------------+
//|                                                   valuechart.mq4 |
//|                                                      Julien Moog |
//|                                          julien.moog@laposte.net |
//+------------------------------------------------------------------+
//===========
//VALUE_CHART
//===========
// Inspiration:
// Mark W. Helweg and David C. Stendahl
// Smallcaps90

#property link      "julien.moog@laposte.net"
#property indicator_separate_window
//Limites des surachats et des surventes
#property  indicator_level1  8
#property  indicator_level2  4
#property  indicator_level3  -4
#property  indicator_level4  -8
#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_color4 Magenta
double vo[],vh[],vb[],vc[];
int p1=5;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(4);
   SetIndexBuffer(0, vo);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 1);    
   SetIndexDrawBegin(0, p1);
   SetIndexBuffer(1, vh);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 1);    
   SetIndexDrawBegin(1, p1);
   SetIndexBuffer(2, vb);
   SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, 1);    
   SetIndexDrawBegin(2, p1);
   SetIndexBuffer(3, vc);
   SetIndexStyle(3, DRAW_LINE, STYLE_SOLID, 1);    
   SetIndexDrawBegin(3, p1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {   
   int    counted_bars=IndicatorCounted(),i;   
   double m1,dvu;
   
   if(Bars<=p1) return(0);
//---- initial zero
   if(counted_bars<1)
      {
      for(i=1;i<=p1;i++) 
         {
         vo[Bars-i]=0.0;   
         vh[Bars-i]=0.0;   
         vb[Bars-i]=0.0;   
         vc[Bars-i]=0.0;   
         }
      }
//----
   i=Bars-p1-1;
   if(counted_bars>=p1) i=Bars-counted_bars-1;
   while(i>=0)
      {
      //Ligne moyenne sur P1 (=5) jours
      m1=0.5*(High[i]+Low[i]);
      m1=m1+0.5*(High[i+1]+Low[i+1]);
      m1=m1+0.5*(High[i+2]+Low[i+2]);
      m1=m1+0.5*(High[i+3]+Low[i+3]);
      m1=m1+0.5*(High[i+4]+Low[i+4]);
      m1=m1/5; 
      //Dynamic Volatility Units     
      dvu=High[i]-Low[i];
      dvu=dvu+(High[i+1]-Low[i+1]);
      dvu=dvu+(High[i+2]-Low[i+2]);
      dvu=dvu+(High[i+3]-Low[i+3]);
      dvu=dvu+(High[i+4]-Low[i+4]);
      dvu=dvu/5;
      dvu=dvu*0.2;
      //Valeurs relatives des ouvertures, des hautes, 
      //des basses et des clotures
      vo[i]=Open[i]-m1;      
      vh[i]=High[i]-m1;
      vb[i]=Low[i]-m1;
      vc[i]=Close[i]-m1;
      //Correction par les DVU
      if (dvu!=0)
         {
         vo[i]=vo[i]/dvu;
         vh[i]=vh[i]/dvu;
         vb[i]=vb[i]/dvu;
         vc[i]=vc[i]/dvu;
         }
      else
         {
         vo[i]=0;
         vh[i]=0;
         vb[i]=0;
         vc[i]=0;        
         }  
      //Autre adaptation possible avec des points
      /* 
      if (vh>l1) pth=vh;
      if (vh>l2 && vh<l1) pmh=vh;
      if (vb<l4) ptb=vb;
      if (vb<l3 && vb>l4) pmb=vb;   
      */ 
      i--;        
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+